// Generated by gtkmmproc -- DO NOT MODIFY!

#include <libgnomeuimm/app.h>
#include <libgnomeuimm/private/app_p.h>

// -*- C++ -*-
/* $Id: app.ccg,v 1.9 2002/12/25 20:33:57 murrayc Exp $ */

/* app.cc
 *
 * Copyright (C) 2000 The Gtk-- Development Team
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgnomeuimm/app-callback.h>
#include <gtkmm/menubar.h>
#include <gtkmm/accelgroup.h>
#include <gtkmm/toolbar.h>
#include <gtkmm/togglebutton.h>
#include <libgnomeuimm/app.h>
//#include <libgnomeuimm/dock-item.h>
//#include <libgnomeui/gnome-stock.h>
#include <libgnomeui/gnome-uidefs.h>
//#include <libgnome/gnome-i18n.h>

namespace Gnome
{

namespace UI
{

App::App(const Glib::ustring& appname)
  : Gtk::Window(GTK_WINDOW(g_object_new(get_type(),0)))
{
  gnome_app_construct(gobj(),
		      appname.c_str(),
		      0);
}

App::App(const Glib::ustring& appname, const Glib::ustring& title)
  : Gtk::Window(GTK_WINDOW(g_object_new(get_type(),0)))
{
  gnome_app_construct(gobj(),
		      appname.c_str(),
		      title.c_str());
}

void App::add(Gtk::Widget&)
{
  //overriden as private, so this should never be called.
}

Items::Array<Items::SubTree>&
App::create_menus(const Items::Array<Items::SubTree> &info)
{
  menus_=info; //Copy for use later by install_menu_hints();.
  gnome_app_create_menus(gobj(), menus_.gobj());
    
  return menus_;
}

Items::Array<Items::Info>&
App::insert_menus(const Glib::ustring& path, const Items::Array<Items::Info> &menuinfo)
{
  //Items::Info must continue to exist while the menu item exists.
  //because GNOME does not make its own copies of some data.
  //This memory will not be released when remove_menus() is called.

  //Because Array is created implicitly by converting from list/vector/whatever,
  //we can not ask the calling code to do its own memory management.
  //This memory accumulation is unpleasant, 
  //but we live in hope that the GNOME menu api will be fixed one day.
  
  listUIArray_.push_back(menuinfo);
  Items::Array<Items::Info>& refArray = listUIArray_.back();
  
  gnome_app_insert_menus(gobj(), path.c_str(), refArray.gobj());

  return refArray;
} 


void
App::install_menu_hints()
{
  gnome_app_install_menu_hints(gobj(), menus_.gobj());
}

Items::Array<Items::Info>&
App::create_toolbar(const Items::Array<Items::Info>& info)
{
  toolbars_ = info;

  /* //debug stuff:
  GnomeUIInfo* pArray = info.gobj();
  bool bContinue = true;
  int i = 0;
  while(bContinue)
  {
    GnomeUIInfo* pInfo = (pArray + i);
    g_warning("appdebug item: %d", pInfo->type);
    if(pInfo->type == GNOME_APP_UI_ENDOFINFO)
      bContinue = false;
    else
    {
      if(pInfo->type == GNOME_APP_UI_ITEM)
      {
        const char* pchIcon = (const char*)pInfo->pixmap_info;
        g_warning("  debug: icon=%s", pchIcon);
      }

      i++;
    }
  }
  */
  
  gnome_app_create_toolbar(gobj(), toolbars_.gobj());

  return toolbars_;
}

} /* namespace UI */
} /* namespace Gnome */


namespace
{
} // anonymous namespace


namespace Glib
{

Gnome::UI::App* wrap(GnomeApp* object, bool take_copy)
{
  return dynamic_cast<Gnome::UI::App *> (Glib::wrap_auto ((GObject*)(object), take_copy));
}

} /* namespace Glib */

namespace Gnome
{

namespace UI
{


/* The *_Class implementation: */

const Glib::Class& App_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &App_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gnome_app_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:
  }

  return *this;
}

void App_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);

}


Glib::ObjectBase* App_Class::wrap_new(GObject* o)
{
  return new App((GnomeApp*)(o)); //top-level windows can not be manage()ed.

}


/* The implementation: */

App::App(const Glib::ConstructParams& construct_params)
:
  Gtk::Window(construct_params)
{
  }

App::App(GnomeApp* castitem)
:
  Gtk::Window((GtkWindow*)(castitem))
{
  }

App::~App()
{
  destroy_();
}

App::CppClassType App::app_class_; // initialize static member

GType App::get_type()
{
  return app_class_.init().get_type();
}

GType App::get_base_type()
{
  return gnome_app_get_type();
}


void App::set_menus(Gtk::MenuBar& menubar)
{
  gnome_app_set_menus(gobj(), menubar.gobj());
}

void App::set_toolbar(Gtk::Toolbar& toolbar)
{
  gnome_app_set_toolbar(gobj(), toolbar.gobj());
}

void App::set_statusbar(Gtk::Widget& statusbar)
{
  gnome_app_set_statusbar(gobj(), (statusbar).gobj());
}

void App::set_statusbar_custom(Gtk::Container& container, Gtk::Widget& statusbar)
{
  gnome_app_set_statusbar_custom(gobj(), container.Gtk::Widget::gobj(), (statusbar).gobj());
}

void App::set_contents(Gtk::Widget& contents)
{
  gnome_app_set_contents(gobj(), (contents).gobj());
}

void App::add_toolbar(Gtk::Toolbar& toolbar, const Glib::ustring& name, BonoboDockItemBehavior behavior, BonoboDockPlacement placement, int band_num, int band_position, int offset)
{
  gnome_app_add_toolbar(gobj(), toolbar.gobj(), name.c_str(), behavior, placement, band_num, band_position, offset);
}

Gtk::Widget* App::add_docked(Gtk::Widget& widget, const Glib::ustring& name, BonoboDockItemBehavior behavior, BonoboDockPlacement placement, int band_num, int band_position, int offset)
{
  return Glib::wrap(gnome_app_add_docked(gobj(), (widget).gobj(), name.c_str(), behavior, placement, band_num, band_position, offset));
}

void App::add_dock_item(BonoboDockItem* item, BonoboDockPlacement placement, int band_num, int band_position, int offset)
{
  gnome_app_add_dock_item(gobj(), item, placement, band_num, band_position, offset);
}

void App::enable_layout_config(gboolean enable)
{
  gnome_app_enable_layout_config(gobj(), enable);
}

BonoboDock* App::get_dock()
{
  return gnome_app_get_dock(gobj());
}

BonoboDockItem* App::get_dock_item_by_name(const Glib::ustring& name)
{
  return gnome_app_get_dock_item_by_name(gobj(), name.c_str());
}

void App::remove_menus(const Glib::ustring& path, int items)
{
  gnome_app_remove_menus(gobj(), path.c_str(), items);
}

void App::remove_menu_range(const Glib::ustring& path, int start, int items)
{
  gnome_app_remove_menu_range(gobj(), path.c_str(), start, items);
}


} // namespace UI

} // namespace Gnome


